(function(global, factory) {
    /* eslint-disable no-undef */

    /* AMD */ if (typeof define === 'function' && define.amd)
        define(["protobuf"], factory);
    
    /* CommonJS */ else if (typeof require === 'function' && typeof module === 'object' && module && module.exports)
        module.exports = factory(require("protobufjs/runtime"));

    /* eslint-enable no-undef */
})(this, function($protobuf) {
    "use strict"; // eslint-disable-line strict

    // Lazily resolved type references
    var $lazyTypes = [];
    
    // Exported root namespace
    var $root = {};
    
    /** @alias A */
    $root.A = (function() {
    
        /**
         * Constructs a new A.
         * @exports A
         * @constructor
         * @param {Object} [properties] Properties to set
         */
        function A(properties) {
            if (properties) {
                var keys = Object.keys(properties);
                for (var i = 0; i < keys.length; ++i)
                    this[keys[i]] = properties[keys[i]];
            }
        }
    
        /** @alias A.prototype */
        var $prototype = A.prototype;
    
        /**
         * A a.
         * @name A#a
         * @type {number}
         */
        $prototype["a"] = 0;
    
        /**
         * Encodes the specified A.
         * @function
         * @param {A|Object} message A or plain object to encode
         * @param {Writer} [writer] Writer to encode to
         * @returns {Writer} Writer
         */
        A.encode = (function() {
            /* eslint-disable */
            var Writer = $protobuf.Writer;
            var util = $protobuf.util;
            var types; $lazyTypes.push(types = [null]);
            return function encode(m, w) {
                w||(w=Writer.create())
                if(m["a"]!==undefined&&m["a"]!==0)
                    w.tag(1,0).uint32(m["a"])
                return w
            }
            /* eslint-enable */
        })();
    
        /**
         * Encodes the specified A, length delimited.
         * @param {A|Object} message A or plain object to encode
         * @param {Writer} [writer] Writer to encode to
         * @returns {Writer} Writer
         */
        A.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };
    
        /**
         * Decodes a A from the specified reader or buffer.
         * @function
         * @param {Reader|Uint8Array} readerOrBuffer Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {A} A
         */
        A.decode = (function() {
            /* eslint-disable */
            var Reader = $protobuf.Reader;
            var util = $protobuf.util;
            var types; $lazyTypes.push(types = [null]);
            return function decode(r, l) {
                r instanceof Reader||(r=Reader.create(r))
                var c=l===undefined?r.len:r.pos+l,m=new $root.A
                while(r.pos<c){
                    var t=r.tag()
                    switch(t.id){
                        case 1:
                            m["a"]=r.uint32()
                            break
                        default:
                            r.skipType(t.wireType)
                            break
                    }
                }
                return m
            }
            /* eslint-enable */
        })();
    
        /**
         * Decodes a A from the specified reader or buffer, length delimited.
         * @param {Reader|Uint8Array} readerOrBuffer Reader or buffer to decode from
         * @returns {A} A
         */
        A.decodeDelimited = function decodeDelimited(readerOrBuffer) {
            readerOrBuffer = readerOrBuffer instanceof $protobuf.Reader ? readerOrBuffer : $protobuf.Reader(readerOrBuffer);
            return this.decode(readerOrBuffer, readerOrBuffer.uint32());
        };
    
        /**
         * Verifies a A.
         * @param {A|Object} message A or plain object to verify
         * @returns {?string} `null` if valid, otherwise the reason why it is not
         */
        A.verify = (function() {
            /* eslint-disable */
            var util = $protobuf.util;
            var types; $lazyTypes.push(types = [null]);
            return function verify(m) {
                if(m["a"]!==undefined){
                    if(!util.isInteger(m["a"]))
                        return"invalid value for field .A.a (integer expected)"
                }
                return null
            }
            /* eslint-enable */
        })();
    
        return A;
    })();
    
    /** @alias B */
    $root.B = (function() {
    
        /**
         * Constructs a new B.
         * @exports B
         * @constructor
         * @param {Object} [properties] Properties to set
         */
        function B(properties) {
            if (properties) {
                var keys = Object.keys(properties);
                for (var i = 0; i < keys.length; ++i)
                    this[keys[i]] = properties[keys[i]];
            }
        }
    
        /** @alias B.prototype */
        var $prototype = B.prototype;
    
        /**
         * B b.
         * @name B#b
         * @type {string}
         */
        $prototype["b"] = "";
    
        /**
         * Encodes the specified B.
         * @function
         * @param {B|Object} message B or plain object to encode
         * @param {Writer} [writer] Writer to encode to
         * @returns {Writer} Writer
         */
        B.encode = (function() {
            /* eslint-disable */
            var Writer = $protobuf.Writer;
            var util = $protobuf.util;
            var types; $lazyTypes.push(types = [null]);
            return function encode(m, w) {
                w||(w=Writer.create())
                if(m["b"]!==undefined&&m["b"]!=="")
                    w.tag(1,2).string(m["b"])
                return w
            }
            /* eslint-enable */
        })();
    
        /**
         * Encodes the specified B, length delimited.
         * @param {B|Object} message B or plain object to encode
         * @param {Writer} [writer] Writer to encode to
         * @returns {Writer} Writer
         */
        B.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };
    
        /**
         * Decodes a B from the specified reader or buffer.
         * @function
         * @param {Reader|Uint8Array} readerOrBuffer Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {B} B
         */
        B.decode = (function() {
            /* eslint-disable */
            var Reader = $protobuf.Reader;
            var util = $protobuf.util;
            var types; $lazyTypes.push(types = [null]);
            return function decode(r, l) {
                r instanceof Reader||(r=Reader.create(r))
                var c=l===undefined?r.len:r.pos+l,m=new $root.B
                while(r.pos<c){
                    var t=r.tag()
                    switch(t.id){
                        case 1:
                            m["b"]=r.string()
                            break
                        default:
                            r.skipType(t.wireType)
                            break
                    }
                }
                return m
            }
            /* eslint-enable */
        })();
    
        /**
         * Decodes a B from the specified reader or buffer, length delimited.
         * @param {Reader|Uint8Array} readerOrBuffer Reader or buffer to decode from
         * @returns {B} B
         */
        B.decodeDelimited = function decodeDelimited(readerOrBuffer) {
            readerOrBuffer = readerOrBuffer instanceof $protobuf.Reader ? readerOrBuffer : $protobuf.Reader(readerOrBuffer);
            return this.decode(readerOrBuffer, readerOrBuffer.uint32());
        };
    
        /**
         * Verifies a B.
         * @param {B|Object} message B or plain object to verify
         * @returns {?string} `null` if valid, otherwise the reason why it is not
         */
        B.verify = (function() {
            /* eslint-disable */
            var util = $protobuf.util;
            var types; $lazyTypes.push(types = [null]);
            return function verify(m) {
                if(m["b"]!==undefined){
                    if(!util.isString(m["b"]))
                        return"invalid value for field .B.b (string expected)"
                }
                return null
            }
            /* eslint-enable */
        })();
    
        return B;
    })();
    
    // Resolve lazy types
    $lazyTypes.forEach(function(types) {
        types.forEach(function(path, i) {
            if (!path)
                return;
            path = path.split('.');
            var ptr = $root;
            while (path.length)
                ptr = ptr[path.shift()];
            types[i] = ptr;
        });
    });

    $protobuf.roots["default"] = $root;

    return $root;
});
